commit fc6e0a52254c2e67ab6634fd0cb12aa694a2e337
Author: Werner Hahn <wh@futureworldsearch.net>
Date:   Mon Sep 10 16:32:50 2018 +0200

    locales

diff --git a/js/locale/en.js b/js/locale/en.js
index eb23151f3..dfcfb0101 100644
--- a/js/locale/en.js
+++ b/js/locale/en.js
@@ -127,6 +127,7 @@ namespace("kivi").setupLocale({
 "There is one or more sections for which no part has been assigned yet; therefore creating the new record is not possible yet.":"",
 "This field must not be empty.":"",
 "This sales order has an active configuration for periodic invoices. If you save then all subsequently created invoices will contain those changes as well, but not those that have already been created. Do you want to continue?":"",
+"This vendor has already a booking with this invoice number, do you really want to add the same invoice number again?":"",
 "Time/cost estimate actions":"",
 "Title":"",
 "Toggle marker":"",
diff --git a/locale/de/all b/locale/de/all
index b1d856ecd..881b9b058 100755
--- a/locale/de/all
+++ b/locale/de/all
@@ -358,6 +358,7 @@ $self->{texts} = {
   'Austria'                     => 'Österreich',
   'Authentification database creation' => 'Anlegen der Datenbank zur Benutzerauthentifizierung',
   'Authentification tables creation' => 'Anlegen der Tabellen zur Benutzerauthentifizierung',
+  'Author'                      => 'Verfasser/in',
   'Auto Send?'                  => 'Auto. Versand?',
   'Automatic date calculation'  => 'Automatische Datumsberechnung',
   'Automatic deletion of leading, trailing and excessive (repetitive) spaces in customer or vendor names' => 'Automatisches Löschen von voran-/nachgestellten und aufeinanderfolgenden Leerzeichen im Kunden- oder Lieferantennamen',
@@ -1519,8 +1520,8 @@ $self->{texts} = {
   'Hide help text'              => 'Hilfetext verbergen',
   'Hide mappings (csv_import)'  => 'Spaltenzuordnungen verbergen',
   'Hide settings'               => 'Einstellungen verbergen',
-  'Hint: Not all VC Numbers are personal accounts compliant' => 'Hinweis: Nicht alle Kunden-/Lieferantennummern sind DATEV-Personenkonten kompatibel.',
   'Highest Dunninglevel'        => 'Höchste Mahnstufe',
+  'Hint: Not all VC Numbers are personal accounts compliant' => 'Hinweis: Nicht alle Kunden-/Lieferantennummern sind DATEV-Personenkonten kompatibel.',
   'Hints'                       => 'Hinweise',
   'History'                     => 'Historie',
   'History Search'              => 'Historien Suche',
@@ -1670,7 +1671,6 @@ $self->{texts} = {
   'Invoice Field 2'             => 'Belegfeld 2',
   'Invoice Number'              => 'Rechnungsnummer',
   'Invoice Number missing!'     => 'Rechnungsnummer fehlt!',
-  'Invoice Total'               => '',
   'Invoice deleted!'            => 'Rechnung gelöscht!',
   'Invoice filter'              => 'Rechnungsfilter',
   'Invoice for fees'            => 'Rechnung über Gebühren',
@@ -1823,6 +1823,7 @@ $self->{texts} = {
   'MD'                          => 'PT',
   'MIME type'                   => 'MIME-Typ',
   'MT940 import'                => 'MT940 Import',
+  'Mails'                       => 'Emails',
   'Main Preferences'            => 'Grundeinstellungen',
   'Main sorting'                => 'Hauptsortierung',
   'Make'                        => 'Lieferant',
@@ -1919,6 +1920,7 @@ $self->{texts} = {
   'Net value in closed delivery orders' => 'Netto in geschlossenen Lieferscheinen',
   'Net value transferred in / out' => 'Netto ein- /ausgelagert',
   'Net value without delivery orders' => 'Netto ohne Lieferschein',
+  'Net.Turnover'                => 'Netto Umsatz',
   'Netherlands'                 => 'Niederlande',
   'Netto Terms'                 => 'Zahlungsziel netto',
   'New Password'                => 'Neues Passwort',
@@ -2106,6 +2108,7 @@ $self->{texts} = {
   'Open'                        => 'Offen',
   'Open Amount'                 => 'Offener Betrag',
   'Open Items'                  => 'Offene Posten',
+  'Open Orders'                 => 'Offene Aufträge',
   'Open a further kivitendo window or tab' => 'Weiteres kivitendo-Fenster/-Tab öffnen',
   'Open amount'                 => 'offener Betrag',
   'Open in new window'          => 'In neuem Fenster öffnen.',
@@ -2130,6 +2133,7 @@ $self->{texts} = {
   'Order probability & expected billing date' => 'Auftragswahrscheinlichkeit & vorrauss. Abrechnungsdatum',
   'Order value periodicity'     => 'Auftragswert basiert auf Periodizität',
   'Order/Item row name'         => 'Name der Auftrag-/Positions-Zeilen',
+  'Order/RFQ Number'            => 'Belegnummer',
   'OrderItem'                   => 'Position',
   'Ordered'                     => 'Von Kunden bestellt',
   'Orders'                      => 'Aufträge',
@@ -2506,6 +2510,7 @@ $self->{texts} = {
   'Reconcile'                   => 'Abgleichen',
   'Reconciliation'              => 'Kontenabgleich',
   'Reconciliation with bank'    => 'Kontenabgleich mit Bank',
+  'Record Type'                 => 'Belegtyp',
   'Record Vendor Invoice'       => 'Einkaufsrechnung erfassen',
   'Record in'                   => 'Buchen auf',
   'Record number'               => 'Belegnummer',
@@ -2514,6 +2519,7 @@ $self->{texts} = {
   'Record\'s files'             => 'Belegdateien',
   'Recorded Tax'                => 'Gespeicherte Steuern',
   'Recorded taxkey'             => 'Gespeicherter Steuerschlüssel',
+  'Records'                     => 'Belege',
   'Reduced Master Data'         => 'Abschlag',
   'Reference'                   => 'Referenz',
   'Reference / Invoice Number'  => 'Referenz / Rechnungsnummer',
@@ -3598,10 +3604,9 @@ $self->{texts} = {
   'Trial Balance'               => 'Summen- und Saldenliste',
   'Trial balance between %s and %s' => 'Summen- und Saldenlisten vom %s bis zum %s',
   'Trying to call a sub without a name' => 'Es wurde versucht, eine Unterfunktion ohne Namen aufzurufen.',
-  'TypAbbreviation'             => 'Abkürzung des Artikel-Typs',
   'Turnover'                    => 'Umsätze',
-  'Turnovers'                   => 'Umsätze',
   'Turnoverstatistic'           => 'Umsatzstatistik',
+  'TypAbbreviation'             => 'Abkürzung des Artikel-Typs',
   'Type'                        => 'Typ',
   'Type abbreviation'           => 'Typen-Abkürzung',
   'Type can be either \'part\', \'service\' or \'assembly\'.' => 'Der Typ kann entweder \'part\' (für Waren), \'service\' (für Dienstleistungen) oder \'assembly\' (für Erzeugnisse) enthalten.',
diff --git a/locale/en/all b/locale/en/all
index cb36002c8..2cdf5b8ff 100644
--- a/locale/en/all
+++ b/locale/en/all
@@ -358,6 +358,7 @@ $self->{texts} = {
   'Austria'                     => '',
   'Authentification database creation' => '',
   'Authentification tables creation' => '',
+  'Author'                      => '',
   'Auto Send?'                  => '',
   'Automatic date calculation'  => '',
   'Automatic deletion of leading, trailing and excessive (repetitive) spaces in customer or vendor names' => '',
@@ -1093,6 +1094,7 @@ $self->{texts} = {
   'Dunning overview'            => '',
   'Dunning status'              => '',
   'Dunnings'                    => '',
+  'Dunningstatistic'            => '',
   'Duplicate in CSV file'       => '',
   'Duplicate in database'       => '',
   'During the next update a taxkey 0 with tax rate of 0 will automatically created.' => '',
@@ -1518,6 +1520,7 @@ $self->{texts} = {
   'Hide help text'              => '',
   'Hide mappings (csv_import)'  => '',
   'Hide settings'               => '',
+  'Highest Dunninglevel'        => '',
   'Hint: Not all VC Numbers are personal accounts compliant' => '',
   'Hints'                       => '',
   'History'                     => '',
@@ -1820,6 +1823,7 @@ $self->{texts} = {
   'MD'                          => '',
   'MIME type'                   => '',
   'MT940 import'                => '',
+  'Mails'                       => '',
   'Main Preferences'            => '',
   'Main sorting'                => '',
   'Make'                        => '',
@@ -1891,6 +1895,7 @@ $self->{texts} = {
   'Module name'                 => '',
   'Monat'                       => '',
   'Month'                       => '',
+  'Month/Year'                  => '',
   'Monthly'                     => '',
   'More than one control file with the tag \'%s\' exist.' => '',
   'More than one file selected, please set only one checkbox!' => '',
@@ -1915,6 +1920,7 @@ $self->{texts} = {
   'Net value in closed delivery orders' => '',
   'Net value transferred in / out' => '',
   'Net value without delivery orders' => '',
+  'Net.Turnover'                => '',
   'Netherlands'                 => '',
   'Netto Terms'                 => '',
   'New Password'                => '',
@@ -2101,6 +2107,8 @@ $self->{texts} = {
   'Oops. No valid action found to dispatch. Please report this case to the kivitendo team.' => '',
   'Open'                        => '',
   'Open Amount'                 => '',
+  'Open Items'                  => '',
+  'Open Orders'                 => '',
   'Open a further kivitendo window or tab' => '',
   'Open amount'                 => '',
   'Open in new window'          => '',
@@ -2125,6 +2133,7 @@ $self->{texts} = {
   'Order probability & expected billing date' => '',
   'Order value periodicity'     => '',
   'Order/Item row name'         => '',
+  'Order/RFQ Number'            => '',
   'OrderItem'                   => '',
   'Ordered'                     => '',
   'Orders'                      => '',
@@ -2501,6 +2510,7 @@ $self->{texts} = {
   'Reconcile'                   => '',
   'Reconciliation'              => '',
   'Reconciliation with bank'    => '',
+  'Record Type'                 => '',
   'Record Vendor Invoice'       => '',
   'Record in'                   => '',
   'Record number'               => '',
@@ -2509,6 +2519,7 @@ $self->{texts} = {
   'Record\'s files'             => '',
   'Recorded Tax'                => '',
   'Recorded taxkey'             => '',
+  'Records'                     => '',
   'Reduced Master Data'         => '',
   'Reference'                   => '',
   'Reference / Invoice Number'  => '',
@@ -3502,6 +3513,7 @@ $self->{texts} = {
   'This update will change the nature the onhand of goods is tracked.' => '',
   'This user is a member in the following groups' => '',
   'This user will have access to the following clients' => '',
+  'This vendor has already a booking with this invoice number, do you really want to add the same invoice number again?' => '',
   'This vendor has already been added.' => '',
   'This vendor number is already in use.' => '',
   'This will apply a 3% reduction to the master data price before entering it into the record item.' => '',
@@ -3591,6 +3603,8 @@ $self->{texts} = {
   'Trial Balance'               => '',
   'Trial balance between %s and %s' => '',
   'Trying to call a sub without a name' => '',
+  'Turnover'                    => '',
+  'Turnoverstatistic'           => '',
   'TypAbbreviation'             => '',
   'Type'                        => '',
   'Type abbreviation'           => '',