commit 77808df0450c46d45e4cd20f95c632e6e70c687b
Author: Werner Hahn <wh@futureworldsearch.net>
Date:   Thu Feb 22 11:23:56 2018 +0100

    DispositionManager Übersetzungen und Button 'add_to_basket'
    
    beim Anlegen eines Artikel disabled

diff --git a/SL/Controller/Part.pm b/SL/Controller/Part.pm
index cfb27296c..7c42f6c0f 100644
--- a/SL/Controller/Part.pm
+++ b/SL/Controller/Part.pm
@@ -1664,7 +1664,8 @@ sub _setup_form_action_bar {
       action => [
         t8('Add to basket'),
         call     => [ 'kivi.Part.add_to_basket' ],
-        disabled => $self->_is_in_purchase_basket ? t8('Part already in purchasebasket')
+        disabled => !$self->part->id       ? t8('This object has not been saved yet.')
+                  : $self->_is_in_purchase_basket ? t8('Part already in purchasebasket')
                   : !scalar @{$self->part->makemodels} ? t8('No vendors to add to purchasebasket')
                   : undef,
       ],
diff --git a/locale/de/all b/locale/de/all
index fc8b5ac7b..12f66b961 100644
--- a/locale/de/all
+++ b/locale/de/all
@@ -274,6 +274,8 @@ $self->{texts} = {
   'Add text block'              => 'Textblock erfassen',
   'Add time recording article'  => 'Artikel für Zeiterfassung erfassen',
   'Add title'                   => 'Titel hinzufügen',
+  'Add to basket'               => 'Einkaufen',
+  'Add to purchase basket'      => 'Einkaufen',
   'Add unit'                    => 'Einheit hinzufügen',
   'Added sections and function blocks: #1' => 'Hinzugefügte Abschnitte und Funktionsblöcke: #1',
   'Added text blocks: #1'       => 'Hinzugefügte Textblöcke: #1',
@@ -894,6 +896,7 @@ $self->{texts} = {
   'Create new version'          => 'Neue Version anlegen',
   'Create one from the context menu by right-clicking on this text.' => 'Erstellen Sie einen aus dem Kontextmenü, indem Sie auf diesen Text rechtsklicken.',
   'Create order'                => 'Auftrag erstellen',
+  'Create purchase order'       => 'Lieferauftrag erstellen',
   'Create sales invoices with Factur-X/ZUGFeRD data' => 'Verkaufsrechnungen mit Factur-X-/ZUGFeRD-Daten erzeugen',
   'Create sales invoices with Swiss QR-bill' => 'Verkaufsrechnungen mit Schweizer QR-Rechnung erzeugen',
   'Create tables'               => 'Tabellen anlegen',
@@ -2191,6 +2194,7 @@ $ ./scripts/installation_check.pl',
   'List of jobs'                => 'Jobliste',
   'List of tax zones'           => 'Liste der Steuerzonen',
   'List open SEPA exports'      => 'Noch nicht ausgeführte SEPA-Exporte anzeigen',
+  'List short onhand'           => 'Meldebestand',
   'List time recordings of all staff members' => 'Zeiterfassungseinträge aller Mitarbeiter anzeigen',
   'Listprice'                   => 'Listenpreis',
   'Load'                        => 'Laden',
@@ -2292,6 +2296,7 @@ $ ./scripts/installation_check.pl',
   'Microfiche'                  => 'Mikrofilm',
   'Minimize Panel'              => 'Panel minimieren',
   'Minimum Amount'              => 'Mindestbetrag',
+  'Minimum order quantity'      => 'Mindestbestellmenge',
   'Miscellaneous'               => 'Verschiedenes',
   'Missing \'description\' field.' => 'Fehlendes Feld \'description\'.',
   'Missing \'tag\' field.'      => 'Fehlendes Feld \'tag\'.',
@@ -2392,6 +2397,7 @@ $ ./scripts/installation_check.pl',
   'No Shopdescription'          => 'Keine Shop-Artikelbeschreibung',
   'No Shopimages'               => 'Keine Shop-Bilder',
   'No VAT Info for this Factur-X/ZUGFeRD invoice, please ask your vendor to add this for his Factur-X/ZUGFeRD data.' => 'Konnte keine UST-ID für diese Factur-X-/ZUGFeRD-Rechnungen finden, bitte fragen Sie bei Ihren Lieferanten nach, ob dieses Feld im Factur-X-/ZUGFeRD-Datensatz gesetzt wird.',
+  'No Vendor'                   => 'Kein Lieferant',
   'No Vendor was found matching the search parameters.' => 'Zu dem Suchbegriff wurde kein Händler gefunden',
   'No account selected. Please select an account.' => 'Kein Konto ausgewählt. Bitte Konto auswählen.',
   'No action defined.'          => 'Keine Aktion definiert.',
@@ -2481,6 +2487,7 @@ $ ./scripts/installation_check.pl',
   'No valid number entered for pricegroup "#1".' => 'Für Preisgruppe "#1" wurde keine gültige Nummer eingegeben.',
   'No vendor has been selected yet.' => 'Es wurde noch kein Lieferant ausgewählt.',
   'No vendor selected or found!' => 'Kein Lieferant ausgewählt oder gefunden!',
+  'No vendors to add to purchasebasket' => 'Kein Lieferant',
   'No warehouse has been created yet or the quantity of the bins is not configured yet.' => 'Es wurde noch kein Lager angelegt, bzw. die dazugehörigen Lagerplätze sind noch nicht konfiguriert.',
   'No webdav backend enabled.'  => 'WebDAV nicht aktiviert.',
   'No year given for method year' => 'Für diese Exportmethode wird ein Jahr benötigt',
@@ -2601,12 +2608,15 @@ $ ./scripts/installation_check.pl',
   'Order item search'           => 'Auftragsartikelsuche',
   'Order probability'           => 'Auftragswahrscheinlichkeit',
   'Order probability & expected billing date' => 'Auftragswahrscheinlichkeit & Voraussichtliches Abrechnungsdatum',
+  'Order quantity'              => 'Bestellmenge',
   'Order value periodicity'     => 'Auftragswert basiert auf Periodizität',
   'Order/Item row name'         => 'Name der Auftrag-/Positions-Zeilen',
   'Order/Item/Stock row name'   => 'Name der Auftrag-/Positions-/Lager-Zeilen',
   'Order/RFQ Number'            => 'Belegnummer',
   'OrderItem'                   => 'Position',
   'Ordered'                     => 'Von Kunden bestellt',
+  'Ordered qty'                 => 'bestellt',
+  'Ordered purchase'            => 'Bestellte Menge',
   'Orders'                      => 'Aufträge',
   'Orders / Delivery Orders deleteable' => 'Aufträge / Lieferscheine löschbar',
   'Orders in Webshop'           => 'Bestellungen in Webshop',
@@ -2676,6 +2686,9 @@ $ ./scripts/installation_check.pl',
   'Part Test'                   => 'Artikel-Test',
   'Part Type'                   => 'Artikel-Typ',
   'Part Unit'                   => 'Einheit',
+  'Part added to purchasebasket' => 'Zu Einkaufkorb hinzugefügt',
+  'Part already in purchasebasket' => 'Schon im Einkaufskorb',
+  'Part already in purchasebasket or has no vendor' => 'Artikel ist schon im Bestellwarenkorb oder hat keinen Lieferanten',
   'Part classifications'        => 'Artikel-Klassifizierungen',
   'Part marked as "Shop part"'  => 'Markiert als Shopartikel',
   'Part picker'                 => 'Artikelauswahl',
@@ -2690,6 +2703,7 @@ $ ./scripts/installation_check.pl',
   'Parts Classification'        => 'Artikel-Klassifizierung',
   'Parts Inventory'             => 'Warenliste',
   'Parts Master Data'           => 'Artikelstammdaten',
+  'Parts short onhand'          => 'Artikel mit geringer Lagermenge',
   'Parts with existing part numbers' => 'Artikel mit existierender Artikelnummer',
   'Parts, services and assemblies' => 'Waren, Dienstleistungen und Erzeugnisse',
   'Partsgroup'                  => 'Warengruppe',
@@ -2975,6 +2989,7 @@ $ ./scripts/installation_check.pl',
   'Purchase Reclamation'        => 'Einkaufsreklamation',
   'Purchase Reclamations'       => 'Einkaufsreklamationen',
   'Purchase Reclamations deleteable' => 'Einkaufsreklamationen löschbar',
+  'Purchase basket'             => 'Einkaufswarenkorb',
   'Purchase delivery order'     => 'Lieferschein (Einkauf)',
   'Purchase invoices'           => 'Einkaufsrechnungen',
   'Purchase invoices changeable' => 'Änderbarkeit von Einkaufsrechnunen',
@@ -3091,6 +3106,7 @@ $ ./scripts/installation_check.pl',
   'Registration'                => 'Erfassung',
   'Relaxed (UTF-8)'             => 'Lax (UTF-8)',
   'Release From Stock'          => 'Lagerausgang',
+  'Reload'                      => 'Neu Laden',
   'Remaining'                   => 'Rest',
   'Remaining Amount'            => 'abzurechnender Betrag',
   'Remaining Net Amount'        => 'abzurechnender Nettobetrag',
@@ -3184,6 +3200,7 @@ $ ./scripts/installation_check.pl',
   'Risk'                        => 'Risiko',
   'Risk levels'                 => 'Risikograde',
   'Risks'                       => 'Risikograde',
+  'Rop'                         => 'Mindeslagebestand',
   'Rounding'                    => 'Rundung',
   'Rounding Gain'               => 'Rundungserträge',
   'Rounding Loss'               => 'Rundungsaufwendungen',
@@ -3463,6 +3480,8 @@ $ ./scripts/installation_check.pl',
   'Shoporders'                  => 'Shopbest.',
   'Shops'                       => 'Webshops',
   'Short'                       => 'Knapp',
+  'Short onhand Ordered'        => 'Geringe Lagermenge, aber bestellt',
+  'Short onhand'                => 'Geringe Lagermenge',
   'Should VAT ID or taxnumber be unique for all vendors? This is checked when saving a vendor\'s master data. One of the fields is sufficient and required.' => 'Soll die UStID oder Steuernummer eindeutig über alle Lieferanten sein? Dies wird beim Speichern von Lieferantenstammdaten geprüft. Eines dieser Felder reicht aus und muss angegeben sein.',
   'Should VAT ID or taxnumber be unique for customers? This is checked when saving a customer\'s master data. One of the fields is sufficient and required.' => 'Soll die UStID oder Steuernummer eindeutig über alle Kunden sein? Dies wird beim Speichern von Kundenstammdaten geprüft. Eines dieser Felder reicht aus und muss angegeben sein.',
   'Should ap transactions be and when should they be changeable or deleteable after posting?' => 'Sollen Kreditorenbuchungen nach der Buchung zu ändern oder zu löschen sein?',
@@ -3524,6 +3543,7 @@ $ ./scripts/installation_check.pl',
   'Show overdue sales quotations and requests for quotations...' => 'Überfällige Angebote und Preisanfragen anzeigen...',
   'Show parts'                  => 'Artikel anzeigen',
   'Show parts longdescription (notes) in select list' => 'Langtext in Auswahlliste bei mehreren Treffern im Stammdaten-Bestand anzeigen',
+  'Show purchase basket'        => 'Zeige Einkaufswarenkorb',
   'Show purchase letters report' => 'Einkaufsbriefe zeigen',
   'Show record tab in customer' => 'Zeige Tab Belege in den Kundenstammdaten',
   'Show record tab in vendor'   => 'Zeige Tab Belege in den Lieferantenstammdaten',
@@ -4914,6 +4934,7 @@ $ ./scripts/installation_check.pl',
   'once'                        => 'einmalig',
   'one time'                    => 'einmalig',
   'one-time execution'          => 'einmalige Ausführung',
+  'onhand'                      => 'Auf Lager',
   'only OB Transactions'        => 'nur EB-Buchungen',
   'open'                        => 'Offen',
   'order'                       => 'Reihenfolge',
@@ -4957,6 +4978,7 @@ $ ./scripts/installation_check.pl',
   'revert deleted'              => 'löschen rückgängig',
   'rfq_list'                    => 'anfragenliste',
   'rma_delivery_order_list'     => 'lieferscheinliste_rma',
+  'rop'                         => 'Mindestlagerbestand',
   'running'                     => 'läuft',
   'sales tax identification number' => 'USt-IdNr.',
   'sales_delivery_order_list'   => 'lieferscheinliste_verkauf',