commit 78533e691a4f463f1639d48854c69ad996470a79
Author: Hans P. Schlaepfer <hanspeter.schlaepfer@revamp-it.ch>
Date:   Thu Jul 25 21:08:25 2019 +0200

    Neues Design 2019 Standard-Code templates/webpages/bank_transactions/assign_invoice.html

diff --git a/templates/webpages/bank_transactions/assign_invoice.html b/templates/webpages/bank_transactions/assign_invoice.html
index a2a8cad00..b0ba531af 100644
--- a/templates/webpages/bank_transactions/assign_invoice.html
+++ b/templates/webpages/bank_transactions/assign_invoice.html
@@ -6,74 +6,78 @@
 [% SET debug = 0 %]
 
 <form method="post" action="javascript:kivi.BankTransaction.filter_invoices();" id="assign_invoice_window_form" data-bank-transaction-id="[% HTML.escape(SELF.transaction.id) %]">
-  <b>[%- LxERP.t8("Bank transaction") %]:</b>
-  <table>
-   <tr class="listheading">
-    [% IF debug %]<td>[%- LxERP.t8("ID") %]:</td>[% END %]
-    <td>[%- LxERP.t8("Transdate") %]:</td>
-    <td>[%- LxERP.t8("Amount") %]:</td>
-    <td>[%- LxERP.t8("Remote name") %]:</td>
-    <td>[%- LxERP.t8("Purpose") %]:</td>
-    <td>[%- LxERP.t8("Remote account number") %]:</td>
-    <td>[%- LxERP.t8("Remote bank code") %]:</td>
-   </tr>
 
-   <tr class="listrow">
-    [% IF debug %]<td>[% SELF.transaction.id %]</td>[% END %]
-    <td>[% SELF.transaction.transdate_as_date %]</td>
-    <td>[% LxERP.format_amount(SELF.transaction.amount, 2) %]</td>
-    <td>[% SELF.transaction.remote_name %]</td>
-    <td>[% SELF.transaction.purpose %]</td>
-    <td>[% SELF.transaction.remote_account_number %]</td>
-    <td>[% SELF.transaction.remote_bank_code %]</td>
-   </tr>
-  </table>
-
-  <b>[%- LxERP.t8("Invoice filter") %]:</b>
-  <table>
-   <tr>
-    <th align="right">[%- LxERP.t8("Invoice number") %]</th>
-    <td>[% L.input_tag('invnumber', '', style=style) %]</td>
-
-    <th align="right">[%- LxERP.t8("Customer/Vendor Name") %]</th>
-    <td>[% L.input_tag('vcname', '', style=style) %]</td>
-   </tr>
-
-   <tr>
-    <th align="right">[%- LxERP.t8("Amount") %]</th>
-    <td>[% L.input_tag('amount', '', style=style) %]</td>
-
-    <th align="right">[%- LxERP.t8("Customer/Vendor Number") %]</th>
-    <td>[% L.input_tag('vcnumber', '', style=style) %]</td>
-   </tr>
+<div class="wrapper">
 
-   <tr>
-    <th align="right">[%- LxERP.t8("Invdate from") %]</th>
-    <td>[% L.date_tag('transdatefrom') %]</td>
-
-    <th align="right">[%- LxERP.t8("to (date)") %]</th>
-    <td>[% L.date_tag('transdateto') %]</td>
-   </tr>
+  <table class="tbl-liste">
+    <caption>[% LxERP.t8("Bank transaction") %]</caption>
+    <thead>
+      <tr>
+        [% IF debug %]
+          <td>[% LxERP.t8("ID") %]:</td>
+        [% END %]
+        <td>[% LxERP.t8("Transdate") %]:</td>
+        <td>[% LxERP.t8("Amount") %]:</td>
+        <td>[% LxERP.t8("Remote name") %]:</td>
+        <td>[% LxERP.t8("Purpose") %]:</td>
+        <td>[% LxERP.t8("Remote account number") %]:</td>
+        <td>[% LxERP.t8("Remote bank code") %]:</td>
+      </tr>
+    </thead>
+    <tbody>
+      <tr>
+        [% IF debug %]
+          <td>[% SELF.transaction.id %]</td>
+        [% END %]
+        <td>[% SELF.transaction.transdate_as_date %]</td>
+        <td>[% LxERP.format_amount(SELF.transaction.amount, 2) %]</td>
+        <td>[% SELF.transaction.remote_name %]</td>
+        <td>[% SELF.transaction.purpose %]</td>
+        <td>[% SELF.transaction.remote_account_number %]</td>
+        <td>[% SELF.transaction.remote_bank_code %]</td>
+      </tr>
+    </tbody>
   </table>
 
-  <p>
-   [% L.submit_tag('', LxERP.t8("Search")) %]
-   [% L.button_tag('kivi.BankTransaction.add_selected_invoices()', LxERP.t8("Add invoices"), id='add_selected_record_links_button') %]
-   [% L.button_tag('$("#assign_invoice_window_form").resetForm()', LxERP.t8('Reset')) %]
-   <a href="#" onclick="$('#assign_invoice_window').dialog('close');">[% LxERP.t8("Cancel") %]</a>
-  </p>
+  <table class="tbl-horizontal">
+    <caption>[% LxERP.t8("Invoice filter") %]</caption>
+    <tbody>
+      <tr>
+        <th>[% LxERP.t8("Invoice number") %]</th>
+        <td>[% L.input_tag('invnumber', '', style=style) %]</td>
+        <th>[% LxERP.t8("Customer/Vendor Name") %]</th>
+        <td>[% L.input_tag('vcname', '', style=style) %]</td>
+      </tr>
+      <tr>
+        <th>[% LxERP.t8("Amount") %]</th>
+        <td>[% L.input_tag('amount', '', style=style) %]</td>
+        <th>[% LxERP.t8("Customer/Vendor Number") %]</th>
+        <td>[% L.input_tag('vcnumber', '', style=style) %]</td>
+      </tr>
+      <tr>
+        <th>[% LxERP.t8("Invdate from") %]</th>
+        <td>[% L.date_tag('transdatefrom') %]</td>
+        <th>[% LxERP.t8("to (date)") %]</th>
+        <td>[% L.date_tag('transdateto') %]</td>
+      </tr>
+    </tbody>
+  </table>
 
-  <hr>
+  <div class="buttons">
+    [% L.submit_tag('', LxERP.t8("Search")) %]
+    [% L.button_tag('kivi.BankTransaction.add_selected_invoices()', LxERP.t8("Add invoices"), id='add_selected_record_links_button') %]
+    [% L.button_tag('$("#assign_invoice_window_form").resetForm()', LxERP.t8('Reset'), class='neutral') %]
+    <a href="#" onclick="$('#assign_invoice_window').dialog('close');" class="neutral">[% LxERP.t8("Cancel") %]</a>
+  </div>
 
   <div id="record_list_filtered_list"></div>
 
+</div><!-- /.wrapper -->
+
 </form>
 
-<script type="text/javascript">
-<!--
+<script type="text/javascript"><!--
 $(function() {
   $('#invnumber').focus();
 });
-
-//-->
-</script>
+//--></script>