commit bd6a87822bde06283d29d2890a9b30d228d21f32
Author: Sven Schöling <s.schoeling@googlemail.com>
Date:   Mon Mar 23 17:26:19 2009 +0000

    Vergessener Loaceleslauf

diff --git a/locale/de/admin b/locale/de/admin
index ddda43c04..84d2f5937 100644
--- a/locale/de/admin
+++ b/locale/de/admin
@@ -227,7 +227,6 @@ $self->{subs} = {
   'create_dataset'              => 'create_dataset',
   'create_standard_group'       => 'create_standard_group',
   'create_standard_group_ask'   => 'create_standard_group_ask',
-  'cross(&\@\@)'                => 'cross(&\@\@)',
   'dbcreate'                    => 'dbcreate',
   'dbdelete'                    => 'dbdelete',
   'dbselect_source'             => 'dbselect_source',
diff --git a/locale/de/am b/locale/de/am
index f6dceb903..58aa7371c 100644
--- a/locale/de/am
+++ b/locale/de/am
@@ -377,7 +377,6 @@ $self->{subs} = {
   'config'                      => 'config',
   'continue'                    => 'continue',
   'cov_selection_internal'      => 'cov_selection_internal',
-  'cross(&\@\@)'                => 'cross(&\@\@)',
   'delete'                      => 'delete',
   'delete_account'              => 'delete_account',
   'delete_buchungsgruppe'       => 'delete_buchungsgruppe',
diff --git a/locale/de/amcvar b/locale/de/amcvar
index c500737ab..9009927ab 100644
--- a/locale/de/amcvar
+++ b/locale/de/amcvar
@@ -176,7 +176,6 @@ $self->{subs} = {
   'calculate_qty'               => 'calculate_qty',
   'call_sub'                    => 'call_sub',
   'cov_selection_internal'      => 'cov_selection_internal',
-  'cross(&\@\@)'                => 'cross(&\@\@)',
   'delete'                      => 'delete',
   'delivery_customer_selection' => 'delivery_customer_selection',
   'display_cvar_config_form'    => 'display_cvar_config_form',
diff --git a/locale/de/amtemplates b/locale/de/amtemplates
index 9048a74ec..20f3e1b87 100644
--- a/locale/de/amtemplates
+++ b/locale/de/amtemplates
@@ -174,7 +174,6 @@ $self->{subs} = {
   'calculate_qty'               => 'calculate_qty',
   'call_sub'                    => 'call_sub',
   'cov_selection_internal'      => 'cov_selection_internal',
-  'cross(&\@\@)'                => 'cross(&\@\@)',
   'delivery_customer_selection' => 'delivery_customer_selection',
   'display'                     => 'display',
   'display_template'            => 'display_template',
diff --git a/locale/de/ap b/locale/de/ap
index 2af6a62cb..c99b287bc 100644
--- a/locale/de/ap
+++ b/locale/de/ap
@@ -304,7 +304,6 @@ $self->{subs} = {
   'cov_selection_internal'      => 'cov_selection_internal',
   'create_links'                => 'create_links',
   'create_subtotal_row'         => 'create_subtotal_row',
-  'cross(&\@\@)'                => 'cross(&\@\@)',
   'delete'                      => 'delete',
   'delete_drafts'               => 'delete_drafts',
   'delivery_customer_selection' => 'delivery_customer_selection',
diff --git a/locale/de/ar b/locale/de/ar
index d425de4d5..9f2155d4e 100644
--- a/locale/de/ar
+++ b/locale/de/ar
@@ -310,7 +310,6 @@ $self->{subs} = {
   'cov_selection_internal'      => 'cov_selection_internal',
   'create_links'                => 'create_links',
   'create_subtotal_row'         => 'create_subtotal_row',
-  'cross(&\@\@)'                => 'cross(&\@\@)',
   'delete'                      => 'delete',
   'delete_drafts'               => 'delete_drafts',
   'delivery_customer_selection' => 'delivery_customer_selection',
diff --git a/locale/de/arap b/locale/de/arap
index 5cb4f37de..64ba5de1e 100644
--- a/locale/de/arap
+++ b/locale/de/arap
@@ -172,7 +172,6 @@ $self->{subs} = {
   'check_project'               => 'check_project',
   'continue'                    => 'continue',
   'cov_selection_internal'      => 'cov_selection_internal',
-  'cross(&\@\@)'                => 'cross(&\@\@)',
   'delivery_customer_selection' => 'delivery_customer_selection',
   'format_dates'                => 'format_dates',
   'mark_as_paid_common'         => 'mark_as_paid_common',
diff --git a/locale/de/bp b/locale/de/bp
index f252fdc9f..dbec6e2ce 100644
--- a/locale/de/bp
+++ b/locale/de/bp
@@ -195,7 +195,6 @@ $self->{subs} = {
   'call_sub'                    => 'call_sub',
   'continue'                    => 'continue',
   'cov_selection_internal'      => 'cov_selection_internal',
-  'cross(&\@\@)'                => 'cross(&\@\@)',
   'delivery_customer_selection' => 'delivery_customer_selection',
   'format_dates'                => 'format_dates',
   'list_spool'                  => 'list_spool',
diff --git a/locale/de/common b/locale/de/common
index d468b72cf..b4c28041b 100644
--- a/locale/de/common
+++ b/locale/de/common
@@ -157,7 +157,6 @@ $self->{subs} = {
   'calculate_qty'               => 'calculate_qty',
   'call_sub'                    => 'call_sub',
   'cov_selection_internal'      => 'cov_selection_internal',
-  'cross(&\@\@)'                => 'cross(&\@\@)',
   'delivery_customer_selection' => 'delivery_customer_selection',
   'format_dates'                => 'format_dates',
   'mark_as_paid_common'         => 'mark_as_paid_common',
diff --git a/locale/de/cp b/locale/de/cp
index 5f5ebae57..50f306783 100644
--- a/locale/de/cp
+++ b/locale/de/cp
@@ -210,7 +210,6 @@ $self->{subs} = {
   'check_project'               => 'check_project',
   'continue'                    => 'continue',
   'cov_selection_internal'      => 'cov_selection_internal',
-  'cross(&\@\@)'                => 'cross(&\@\@)',
   'delivery_customer_selection' => 'delivery_customer_selection',
   'form_footer'                 => 'form_footer',
   'form_header'                 => 'form_header',
diff --git a/locale/de/ct b/locale/de/ct
index 265039b37..6c198169e 100644
--- a/locale/de/ct
+++ b/locale/de/ct
@@ -217,7 +217,6 @@ $self->{subs} = {
   'call_sub'                    => 'call_sub',
   'continue'                    => 'continue',
   'cov_selection_internal'      => 'cov_selection_internal',
-  'cross(&\@\@)'                => 'cross(&\@\@)',
   'delete'                      => 'delete',
   'delete_contact'              => 'delete_contact',
   'delete_shipto'               => 'delete_shipto',
diff --git a/locale/de/datev b/locale/de/datev
index a2cc75c0d..147912b68 100644
--- a/locale/de/datev
+++ b/locale/de/datev
@@ -197,7 +197,6 @@ $self->{subs} = {
   'call_sub'                    => 'call_sub',
   'continue'                    => 'continue',
   'cov_selection_internal'      => 'cov_selection_internal',
-  'cross(&\@\@)'                => 'cross(&\@\@)',
   'delivery_customer_selection' => 'delivery_customer_selection',
   'download'                    => 'download',
   'export'                      => 'export',
diff --git a/locale/de/dn b/locale/de/dn
index 657c74e20..4ee9c592e 100644
--- a/locale/de/dn
+++ b/locale/de/dn
@@ -309,7 +309,6 @@ $self->{subs} = {
   'check_form'                  => 'check_form',
   'continue'                    => 'continue',
   'cov_selection_internal'      => 'cov_selection_internal',
-  'cross(&\@\@)'                => 'cross(&\@\@)',
   'customer_details'            => 'customer_details',
   'delivery_customer_selection' => 'delivery_customer_selection',
   'display_row'                 => 'display_row',
diff --git a/locale/de/do b/locale/de/do
index c65312ae9..35ea77d74 100644
--- a/locale/de/do
+++ b/locale/de/do
@@ -336,7 +336,6 @@ $self->{subs} = {
   'check_project'               => 'check_project',
   'continue'                    => 'continue',
   'cov_selection_internal'      => 'cov_selection_internal',
-  'cross(&\@\@)'                => 'cross(&\@\@)',
   'customer_details'            => 'customer_details',
   'delete'                      => 'delete',
   'delete_delivery_order'       => 'delete_delivery_order',
diff --git a/locale/de/drafts b/locale/de/drafts
index 436a9c01c..357a9e71d 100644
--- a/locale/de/drafts
+++ b/locale/de/drafts
@@ -160,7 +160,6 @@ $self->{subs} = {
   'calculate_qty'               => 'calculate_qty',
   'call_sub'                    => 'call_sub',
   'cov_selection_internal'      => 'cov_selection_internal',
-  'cross(&\@\@)'                => 'cross(&\@\@)',
   'delete_drafts'               => 'delete_drafts',
   'delivery_customer_selection' => 'delivery_customer_selection',
   'dont_load_draft'             => 'dont_load_draft',
diff --git a/locale/de/gl b/locale/de/gl
index cd6380d96..dd0b0272d 100644
--- a/locale/de/gl
+++ b/locale/de/gl
@@ -279,7 +279,6 @@ $self->{subs} = {
   'continue'                    => 'continue',
   'cov_selection_internal'      => 'cov_selection_internal',
   'create_subtotal_row'         => 'create_subtotal_row',
-  'cross(&\@\@)'                => 'cross(&\@\@)',
   'delete'                      => 'delete',
   'delivery_customer_selection' => 'delivery_customer_selection',
   'display_form'                => 'display_form',
diff --git a/locale/de/ic b/locale/de/ic
index 7711ef266..727251d11 100644
--- a/locale/de/ic
+++ b/locale/de/ic
@@ -357,7 +357,6 @@ $self->{subs} = {
   'confirm_price_update'        => 'confirm_price_update',
   'continue'                    => 'continue',
   'cov_selection_internal'      => 'cov_selection_internal',
-  'cross(&\@\@)'                => 'cross(&\@\@)',
   'customer_details'            => 'customer_details',
   'delete'                      => 'delete',
   'delivery_customer_selection' => 'delivery_customer_selection',
diff --git a/locale/de/io b/locale/de/io
index 4c02e7915..58fd08ccb 100644
--- a/locale/de/io
+++ b/locale/de/io
@@ -273,7 +273,6 @@ $self->{subs} = {
   'call_sub'                    => 'call_sub',
   'check_form'                  => 'check_form',
   'cov_selection_internal'      => 'cov_selection_internal',
-  'cross(&\@\@)'                => 'cross(&\@\@)',
   'customer_details'            => 'customer_details',
   'delivery_customer_selection' => 'delivery_customer_selection',
   'display_form'                => 'display_form',
diff --git a/locale/de/ir b/locale/de/ir
index a1254820d..79993b601 100644
--- a/locale/de/ir
+++ b/locale/de/ir
@@ -349,7 +349,6 @@ $self->{subs} = {
   'check_project'               => 'check_project',
   'continue'                    => 'continue',
   'cov_selection_internal'      => 'cov_selection_internal',
-  'cross(&\@\@)'                => 'cross(&\@\@)',
   'customer_details'            => 'customer_details',
   'delete'                      => 'delete',
   'delete_drafts'               => 'delete_drafts',
diff --git a/locale/de/is b/locale/de/is
index 0d3cf4da4..c793b8687 100644
--- a/locale/de/is
+++ b/locale/de/is
@@ -375,7 +375,6 @@ $self->{subs} = {
   'continue'                    => 'continue',
   'cov_selection_internal'      => 'cov_selection_internal',
   'credit_note'                 => 'credit_note',
-  'cross(&\@\@)'                => 'cross(&\@\@)',
   'customer_details'            => 'customer_details',
   'delete'                      => 'delete',
   'delete_drafts'               => 'delete_drafts',
diff --git a/locale/de/licenses b/locale/de/licenses
index 23113a638..c0d4aa970 100644
--- a/locale/de/licenses
+++ b/locale/de/licenses
@@ -190,7 +190,6 @@ $self->{subs} = {
   'call_sub'                    => 'call_sub',
   'continue'                    => 'continue',
   'cov_selection_internal'      => 'cov_selection_internal',
-  'cross(&\@\@)'                => 'cross(&\@\@)',
   'delivery_customer_selection' => 'delivery_customer_selection',
   'details'                     => 'details',
   'do_add'                      => 'do_add',
diff --git a/locale/de/login b/locale/de/login
index 384a4cc44..81afb5d1d 100644
--- a/locale/de/login
+++ b/locale/de/login
@@ -432,7 +432,6 @@ $self->{subs} = {
   'create_backorder'            => 'create_backorder',
   'create_subtotal_row'         => 'create_subtotal_row',
   'create_todo_list'            => 'create_todo_list',
-  'cross(&\@\@)'                => 'cross(&\@\@)',
   'customer_details'            => 'customer_details',
   'delete'                      => 'delete',
   'delete_delivery_order'       => 'delete_delivery_order',
diff --git a/locale/de/oe b/locale/de/oe
index 32f8276e1..baa026638 100644
--- a/locale/de/oe
+++ b/locale/de/oe
@@ -396,7 +396,6 @@ $self->{subs} = {
   'cov_selection_internal'      => 'cov_selection_internal',
   'create_backorder'            => 'create_backorder',
   'create_subtotal_row'         => 'create_subtotal_row',
-  'cross(&\@\@)'                => 'cross(&\@\@)',
   'customer_details'            => 'customer_details',
   'delete'                      => 'delete',
   'delete_delivery_order'       => 'delete_delivery_order',
diff --git a/locale/de/pe b/locale/de/pe
index 9a8925b4b..b4c681728 100644
--- a/locale/de/pe
+++ b/locale/de/pe
@@ -180,7 +180,6 @@ $self->{subs} = {
   'call_sub'                    => 'call_sub',
   'continue'                    => 'continue',
   'cov_selection_internal'      => 'cov_selection_internal',
-  'cross(&\@\@)'                => 'cross(&\@\@)',
   'delete'                      => 'delete',
   'delivery_customer_selection' => 'delivery_customer_selection',
   'edit'                        => 'edit',
diff --git a/locale/de/projects b/locale/de/projects
index d0267103d..be748c6df 100644
--- a/locale/de/projects
+++ b/locale/de/projects
@@ -184,7 +184,6 @@ $self->{subs} = {
   'call_sub'                    => 'call_sub',
   'continue'                    => 'continue',
   'cov_selection_internal'      => 'cov_selection_internal',
-  'cross(&\@\@)'                => 'cross(&\@\@)',
   'delete'                      => 'delete',
   'delivery_customer_selection' => 'delivery_customer_selection',
   'display_project_form'        => 'display_project_form',
diff --git a/locale/de/rc b/locale/de/rc
index 57731516e..f1c005d8e 100644
--- a/locale/de/rc
+++ b/locale/de/rc
@@ -179,7 +179,6 @@ $self->{subs} = {
   'call_sub'                    => 'call_sub',
   'continue'                    => 'continue',
   'cov_selection_internal'      => 'cov_selection_internal',
-  'cross(&\@\@)'                => 'cross(&\@\@)',
   'delivery_customer_selection' => 'delivery_customer_selection',
   'display_form'                => 'display_form',
   'done'                        => 'done',
diff --git a/locale/de/todo b/locale/de/todo
index dfb50bda6..7e42b71d4 100644
--- a/locale/de/todo
+++ b/locale/de/todo
@@ -424,7 +424,6 @@ $self->{subs} = {
   'create_backorder'            => 'create_backorder',
   'create_subtotal_row'         => 'create_subtotal_row',
   'create_todo_list'            => 'create_todo_list',
-  'cross(&\@\@)'                => 'cross(&\@\@)',
   'customer_details'            => 'customer_details',
   'delete'                      => 'delete',
   'delete_delivery_order'       => 'delete_delivery_order',
diff --git a/locale/de/ustva b/locale/de/ustva
index 86a9db03e..128724624 100644
--- a/locale/de/ustva
+++ b/locale/de/ustva
@@ -224,7 +224,6 @@ $self->{subs} = {
   'continue'                    => 'continue',
   'cov_selection_internal'      => 'cov_selection_internal',
   'create_steuernummer'         => 'create_steuernummer',
-  'cross(&\@\@)'                => 'cross(&\@\@)',
   'debug'                       => 'debug',
   'delivery_customer_selection' => 'delivery_customer_selection',
   'elster_hash'                 => 'elster_hash',
diff --git a/locale/de/wh b/locale/de/wh
index 26f869f57..bd8fd0142 100644
--- a/locale/de/wh
+++ b/locale/de/wh
@@ -10,6 +10,7 @@ $self->{texts} = {
   'Address'                     => 'Adresse',
   'Advance turnover tax return' => 'Umsatzsteuervoranmeldung',
   'All reports'                 => 'Alle Berichte (Konten&uuml;bersicht, Summen- u. Saldenliste, GuV, BWA, Bilanz, Projektbuchungen)',
+  'Assembly'                    => 'Erzeugnis',
   'Attempt to call an undefined sub named \'%s\'' => 'Es wurde versucht, eine nicht definierte Unterfunktion namens \'%s\' aufzurufen.',
   'Bcc'                         => 'Bcc',
   'Bin'                         => 'Lagerplatz',
@@ -33,6 +34,7 @@ $self->{texts} = {
   'CRM termin'                  => 'Termine',
   'CRM user'                    => 'Admin Benutzer',
   'CSV export -- options'       => 'CSV-Export -- Optionen',
+  'Can not create that quantity with current stock' => 'Ich kann diese Anzahl mit dem gegenwärtigen Lagerbestand nicht herstellen.',
   'Cc'                          => 'Cc',
   'Change Lx-Office installation settings (all menu entries beneath \'System\')' => 'Ver&auml;ndern der Lx-Office-Installationseinstellungen (Men&uuml;punkte unterhalb von \'System\')',
   'Charge Number'               => 'Chargennummer',
@@ -144,6 +146,7 @@ $self->{texts} = {
   'Subject'                     => 'Betreff',
   'The \'tag\' field must only consist of alphanumeric characters or the carachters - _ ( )' => 'Das Feld \'tag\' darf nur aus alphanumerischen Zeichen und den Zeichen - _ ( ) bestehen.',
   'The LDAP server "#1:#2" is unreachable. Please check config/authentication.pl.' => 'Der LDAP-Server "#1:#2" ist nicht erreichbar. Bitte &uuml;berpr&uuml;fen Sie die Angaben in config/authentication.pl.',
+  'The assembly has been created.' => 'Das Erzeugnis wurde hergestellt.',
   'The config file "config/authentication.pl" contained invalid Perl code:' => 'Die Konfigurationsdatei "config/authentication.pl" enthielt ung&uuml;tigen Perl-Code:',
   'The config file "config/authentication.pl" was not found.' => 'Die Konfigurationsdatei "config/authentication.pl" wurde nicht gefunden.',
   'The connection to the LDAP server cannot be encrypted (SSL/TLS startup failure). Please check config/authentication.pl.' => 'Die Verbindung zum LDAP-Server kann nicht verschl&uuml;sselt werden (Fehler bei SSL/TLS-Initialisierung). Bitte &uuml;berpr&uuml;fen Sie die Angaben in config/authentication.pl.',
@@ -229,7 +232,7 @@ $self->{subs} = {
   'call_sub'                    => 'call_sub',
   'continue'                    => 'continue',
   'cov_selection_internal'      => 'cov_selection_internal',
-  'cross(&\@\@)'                => 'cross(&\@\@)',
+  'create_assembly'             => 'create_assembly',
   'delivery_customer_selection' => 'delivery_customer_selection',
   'format_dates'                => 'format_dates',
   'generate_journal'            => 'generate_journal',
@@ -257,6 +260,7 @@ $self->{subs} = {
   'show_no_warehouses_error'    => 'show_no_warehouses_error',
   'show_vc_details'             => 'show_vc_details',
   'stock'                       => 'stock',
+  'transfer_assembly_update_part' => 'transfer_assembly_update_part',
   'transfer_or_removal_prepare_contents' => 'transfer_or_removal_prepare_contents',
   'transfer_parts'              => 'transfer_parts',
   'transfer_parts_selection'    => 'transfer_parts_selection',
@@ -268,6 +272,7 @@ $self->{subs} = {
   'update'                      => 'update',
   'vendor_selection'            => 'vendor_selection',
   'weiter'                      => 'continue',
+  'erzeugnis_fertigen'          => 'create_assembly',
   'neue_ware'                   => 'new_part',
   'einlagern'                   => 'stock',
   'erneuern'                    => 'update',